//+------------------------------------------------------------------+
//| Some Functions of this EA is generated by Expert Advisor Builder |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//|                Please do not remove this header.                 |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                               Boostrade-g01ver02 |
//|                                       Copyright ?2007, Boostrade |
//|                                 http://boostrade.spaces.live.com |
//+------------------------------------------------------------------+
#property copyright "Boostrade-g01ver02 Copyright ?2007, Boostrade"
#property link      "http://boostrade.spaces.live.com"

extern int MagicNumber = 250102; //2 for GBP, 5 for M5, 01 for logic 01, 02 for version 02
extern bool SoundAlert = False; //If need sound alert of trade signals
extern string DST = "*Select if trading in Daylight Saving Time*";
extern bool ifDST = False;
extern int DSValue = 1;
extern string TimeSettings = "*Adjust Daily Trading Time*";
extern int OpenHour = 8; // All time are server time
extern int OpenMinute = 0;
extern int StopOpenHour = 15; 
extern int CloseHour1 = 16;
extern int CloseMinute1 = 0;
extern int CloseHour2 = 15; 
extern int CloseMinute2 = 55;
extern string Lots = "*Adjust Lot Settings based on latest Margin*";
extern double MarginPerLot = 1000;
extern double MinimumML = 1000;
extern int MarginBaseFactor = 100; //Base is 100. Increase it decreases the lot size
extern bool ApplyMM = True; //Apply Money Management
extern double PercentRisk = 10; //10 means 0.1 lot in a mini account starting 1k or 1 lot in a standard account starting 10K, with leverage 100:1
extern double nonMMlots = 0.1;
extern bool MiniLotAtLeast0.1 = True; //Mini account of 500 or below may not function if False and LotsDigit set to 1
extern int LotsDigit = 2; //If you want to increase lot size by 2 digits (0.01)  or 1 digit (0.1). Some dealers don't have 0.01 trades, so remember to switch to 1.
extern int ChartPeriod = 5; //Has to to on M5 chart
extern string SecureProfit = "*Adjust Profit-maximization Settings*";
bool StopLossMode = True; //Stop loss is essential!
extern int StopLoss = 48; //The optimized value
bool TakeProfitMode = True; //Take profit is also essential!
extern int TakeProfit = 158; //The optimized value
bool TrailingStopMode = True; //Trailing stops are always good
extern int TrailingStop = 58; //The optimized value
double PriceBuffer = 0.0008; //The pips to make it for price high and price low
double MacdValueOpen = 0.0002; //The MACD value to filter out unnecesary trades
double MacdValueClose = 0.0015; //The MACD value to close a trade
int BarBack = 1; //1 means the previous bar
bool SignalMail = False; //If email reminder is required
bool EachTickMode = True; //If each ticket is to be checked
int Slippage = 3; //Price slippage

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;
   if (EachTickMode) Current = 0; else Current = 1;
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {

//Check if symbol and timeframe is correct
   if (Symbol() != "GBPUSD")
      {
      Alert("Error: This EA only runs on GBP/USD.\n","Boostrade-g01ver02 Deinitialized.");
      return(0);
      }

   if (Period() != 5)
      {
      Alert("Error: This EA only runs on a M5 chart.\n","Boostrade-g01ver02 Deinitialized.");
      return(0);
      }

//Check PercentRisk
   if (PercentRisk > 50)
      {
      Alert("Warning! Invest over 50% of Equity is TOO RISKY! \n","Trading Terminated.");
      return(0);
      }

//Display
   Comment("Hello ",AccountName(),",\n","Boostrade-g01ver02 at your service.\n","Enjoy Trading and Good Luck!\n","God bless you.");

// Main Program Starts

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+

//Check DST and adjust settings accordingly
   int iOpenHour = OpenHour;
   int StopiOpenHour =StopOpenHour;
   int iCloseHour1 = CloseHour1;
   int iCloseHour2 = CloseHour2;
   if (ifDST == true)
   {
    iOpenHour = OpenHour + DSValue;
    StopiOpenHour = StopOpenHour + DSValue;
    iCloseHour1 = CloseHour1 + DSValue;
    iCloseHour2 = CloseHour2 + DSValue;
   }

//Lots management
  double Lots, PRbase;
  bool MaxLot, HalfLot;
  
   PRbase = MarginPerLot * MarginBaseFactor; 
   if (AccountFreeMargin()/2 >= MinimumML*10) {Lots = AccountFreeMargin() * (PercentRisk / PRbase); MaxLot = true;}
   else {Lots = AccountFreeMargin() * (PercentRisk/PRbase/2); HalfLot = true;}     
   Lots = NormalizeDouble(Lots,LotsDigit);
   if (MiniLotAtLeast0.1 == True)
   {
     if (Lots < 0.1) 
     Lots = 0.1;
   }
   if (ApplyMM == false) Lots = nonMMlots;

//Market Entry and Exit
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;
   double priceHigh, priceLow, maSignal;
   double macdFilter, macdValueBuy, macdValueSell, macdValueCloseBuy, macdValueCloseSell;

   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

       HideTestIndicators(true);
       priceHigh = iHigh(NULL, ChartPeriod, Current + BarBack) + PriceBuffer;
       priceLow = iLow(NULL, ChartPeriod, Current + BarBack) - PriceBuffer;
       maSignal = iMA(NULL, ChartPeriod, 26, 0, MODE_SMMA, PRICE_CLOSE, Current + BarBack);
       macdFilter = iMACD(NULL, ChartPeriod, 3, 26, 1, PRICE_CLOSE, MODE_MAIN, Current + BarBack);
       macdValueBuy = MacdValueOpen * (-1);
       macdValueSell = MacdValueOpen;
       macdValueCloseBuy = MacdValueClose;
       macdValueCloseSell = MacdValueClose * (-1);

   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

               if ((TimeHour(Time[0]) == iCloseHour1 && TimeMinute(Time[0]) == CloseMinute1) || (TimeHour(Time[0]) >= iCloseHour2 && TimeMinute(Time[0]) >= CloseMinute2) || (macdFilter > macdValueCloseBuy && priceLow < maSignal))
               {
                Order = SIGNAL_CLOSEBUY;
               }

            //+------------------------------------------------------------------+
            //| Signal End(Exit Buy)                                             |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SoundAlert == true) PlaySound("CloseTrade");
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+

               if ((TimeHour(Time[0]) == iCloseHour1 && TimeMinute(Time[0]) == CloseMinute1)  || (TimeHour(Time[0]) >= iCloseHour2 && TimeMinute(Time[0]) >= CloseMinute2) || (macdFilter < macdValueCloseSell && priceHigh > maSignal))
               {
                Order = SIGNAL_CLOSESELL;
               }

            //+------------------------------------------------------------------+
            //| Signal End(Exit Sell)                                            |
            //+------------------------------------------------------------------+

            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SoundAlert == true) PlaySound("CloseTrade");
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

      if (TimeHour(Time[0]) >= iOpenHour && TimeHour(Time[0]) < StopiOpenHour && TimeMinute(Time[0]) >= OpenMinute && priceHigh > maSignal && macdFilter < macdValueBuy && macdFilter > macdValueCloseSell)
      {
       Order = SIGNAL_BUY;
      }
      if (TimeHour(Time[0]) >= iOpenHour && TimeHour(Time[0]) < StopiOpenHour && TimeMinute(Time[0]) >= OpenMinute && priceLow < maSignal && macdFilter > macdValueSell && macdFilter < macdValueCloseBuy)
      {
       Order = SIGNAL_SELL;
      }

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {

         if (StopLossMode) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
                if (MaxLot == true) Print("Lots Maximized");
                if (HalfLot == true) Alert("Lots Halved");   
                if (SoundAlert == true) PlaySound("OpenBuy");
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(!IsTrade) {

         if (StopLossMode) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
                if (MaxLot == true) Print("Lots Maximized");
                if (HalfLot == true) Alert("Lots Halved");   
                if (SoundAlert == true) PlaySound("OpenSell");
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);

}
//+------------------------------------------------------------------+